#include <sourcemod>
#include <sdktools>
#include <multicolors>

#pragma semicolon 1
#define PLUGIN_VERSION "1.3.4"


//ConVars
ConVar sStatsEnabled = null;
ConVar sShowStatsOnRound = null;
ConVar sShowStatsOnMap = null;
ConVar sMaxRounds = null;
ConVar sWinLimit = null;
ConVar sCheckMapEndBy = null;


// stats
int timeleft;
int wincountct = 0;
int wincountt = 0;
int firstblood = 0;
int countround = 0;
int kills[MAXPLAYERS+1];
int hs[MAXPLAYERS+1];
int knives[MAXPLAYERS+1];
int hits[MAXPLAYERS+1];
int grenade[MAXPLAYERS];
float damage1[MAXPLAYERS+1];
int killsEnd[MAXPLAYERS+1];
int hsEnd[MAXPLAYERS+1];
int knivesEnd[MAXPLAYERS+1];
int hitsEnd[MAXPLAYERS+1];
int grenadeEnd[MAXPLAYERS];
float damage1End[MAXPLAYERS+1];
char KillerName[MAX_NAME_LENGTH];
char VictimName[MAX_NAME_LENGTH];
char name1[MAX_NAME_LENGTH] = "null";

public Plugin myinfo = 
{
	name = "[CSGO] SLAYER Advance Round Stats",
	author = "SLAYER",
	description = "Show Advance stats on Round End and on Map End (Mvp, Winner, Headshot kills, Knife kills, Total Damage Given, etc)",
	version = PLUGIN_VERSION,
	url = "https://forums.alliedmods.net/member.php?u=293943"
};

public void OnPluginStart()
{
	CreateConVar("advance_stats_version", PLUGIN_VERSION, "Advance Stats plugin version. Please don't change me!", FCVAR_REPLICATED|FCVAR_NOTIFY|FCVAR_DONTRECORD);
	sStatsEnabled = CreateConVar("advance_stats_enabled", "1", "Enable/disable Advance Stats plugin. (0 = Disabled, 1 = Enabled)", FCVAR_NOTIFY, true, 0.0, true, 1.0);
	sShowStatsOnRound = CreateConVar("advance_stats_show_round", "1", "Enable/disable Show Advance Stats on Round End", FCVAR_NOTIFY, true, 0.0, true, 1.0);
	sShowStatsOnMap = CreateConVar("advance_stats_show_map", "1", "Enable/disable Show Advance Stats on Map End", FCVAR_NOTIFY, true, 0.0, true, 1.0);
	sCheckMapEndBy = CreateConVar("advance_stats_map_end_type", "2", "Check Map End Reason by (1 = Timeleft, 2 = Maxrounds, 3 = Winlimit)", FCVAR_NOTIFY);
	sMaxRounds = FindConVar("mp_maxrounds");
	sWinLimit = FindConVar("mp_winlimit");
	HookEvent("round_start", Event_RoundStart, EventHookMode_PostNoCopy);
	HookEvent("round_end", Event_OnRoundEnd, EventHookMode_PostNoCopy);
	HookEvent("player_hurt", Event_PlayerHurt);
	HookEvent("player_death", Event_PlayerDeath);
	AutoExecConfig(true, "SLAYER_Advance_Stats");
}
public void OnMapStart()
{
	countround = -1;
	wincountct = 0;
	wincountt = 0;
	CreateTimer(1.0, TimerCount, _, TIMER_REPEAT);
}
public Action TimerCount(Handle timer)
{
	GetMapTimeLeft(timeleft);
	if(sCheckMapEndBy.IntValue == 1 && timeleft <= 0)
	{
		MapEndText();
		return Plugin_Stop;
	}
	return Plugin_Continue;
}
public void OnMapEnd()
{
	for(new i = 1; i < MAXPLAYERS; i++) // reset stats
	{
		killsEnd[i] = 0;
		hsEnd[i] = 0;
		knivesEnd[i] = 0;
		damage1End[i] = 0.0;
		hitsEnd[i] = 0;
		grenadeEnd[i] = 0;
	}
}

public Event_PlayerDisconnect(Handle event, const char[] name, bool dontBroadcast)
{
	int attacker = GetClientOfUserId(GetEventInt(event, "userid"));
	kills[attacker] = 0;
	hs[attacker] = 0;
	knives[attacker] = 0;
	damage1[attacker] = 0.0;
	hits[attacker] = 0;
	grenade[attacker] = 0;
}
public void Event_RoundStart(Handle event, const char[] name, bool dontBroadcast)
{
	if(sCheckMapEndBy.IntValue == 2)countround++;
	firstblood = 0;
	name1 = "null";
	for(new i = 1; i < MAXPLAYERS; i++) // reset stats
	{
		kills[i] = 0;
		hs[i] = 0;
		knives[i] = 0;
		damage1[i] = 0.0;
		hits[i] = 0;
		grenade[i] = 0;
	}
}
public void Event_OnRoundEnd(Handle event, const char[] name, bool dontBroadcast)
{
	if(sStatsEnabled.BoolValue && sShowStatsOnRound.BoolValue)
	{
		int WinningTeam = GetEventInt(event, "winner");
		int noob = 0;
		int mostkills = 0;
		int mostdamage = 0;
		int mosths = 0;
		int mostknives = 0;
		int mostgrenades = 0;
		char Winner[32];
		if(WinningTeam == 3){Winner = "Counter-Terrorist";if(sCheckMapEndBy.IntValue == 3){wincountct++;}}
		if(WinningTeam == 2){Winner = "Terrorist";if(sCheckMapEndBy.IntValue == 3){wincountt++;}}
		for(new i = 1; i < MaxClients; i++)
		{
			if(IsClientInGame(i) && !IsClientSourceTV(i) && GetClientTeam(i) != 1 && kills[i] > 0)
			{
				if(kills[i] >= kills[mostkills] && damage1[i] > damage1[mostdamage])
				{
					mostkills = i;
				}
				if(hs[i] > 0 && (hs[i] >= hs[mosths]))
				{
					mosths = i;
				}
				if(knives[i] > 0 && (knives[i] >= knives[mostknives]))
				{
					mostknives = i;
				}
				if(grenade[i] > 0 && (grenade[i] >= grenade[mostgrenades]))
				{
					mostgrenades = i;
				}
			}
			if(IsClientInGame(i) && !IsClientSourceTV(i) && GetClientTeam(i) != 1 && damage1[i] <= 0 || damage1[i] < damage1[mostdamage])
			{
				noob = i;
			}
		}
		char noobname[MAX_NAME_LENGTH];
		GetClientName(noob, noobname, sizeof(noobname));
		char mvpname[MAX_NAME_LENGTH];
		GetClientName(mostkills, mvpname, sizeof(mvpname));
		char hname[MAX_NAME_LENGTH];
		GetClientName(mosths, hname, sizeof(hname));
		char kname[MAX_NAME_LENGTH];
		GetClientName(mostknives, kname, sizeof(kname));
		char Gname[MAX_NAME_LENGTH];
		GetClientName(mostgrenades, Gname, sizeof(Gname));
		CPrintToChatAll("{darkred}=============== {purple}[{orchid}★ {green}Round{purple}-{lime}Stats {orchid}★{purple}] {darkred}===============");
		CPrintToChatAll("{lime}★ {darkred}Winner {orchid}: {green}%s", Winner);
		if(mostkills > 0)CPrintToChatAll("{lime}★ {darkred}%s {default}is {lime}MVP {default}with {lime}%i {orchid}Kills {default}by Giving", mvpname, kills[mostkills]); // Name of MVP player
		if(mostkills > 0)CPrintToChatAll("{lime}★{yellow} Damage {lime}%0.0f {default}in {lime}%i {yellow}Hits", damage1[mostkills], hits[mostkills]);
		if(mosths > 0)CPrintToChatAll("{lime}★ {default}HeadHunter {lime}: {lime}%s {default}({lime}%i{default})", hname, hs[mosths]); // Most Headshot Kills in Round by which player
		if(mostknives > 0)CPrintToChatAll("{lime}★ {default}Most Knife kills {lime}: {yellow}%s {default}({yellow}%i{default})", kname, knives[mostknives]); // Most Knife Kills in Round by which player
		if(mostgrenades > 0)CPrintToChatAll("{lime}★ {default}Most Grenade kills {lime}: {lime}%s {default}({lime}%i{default})", Gname, grenade[mostgrenades]); // Most Grenades Kills in Map by which player
		if(noob > 0)CPrintToChatAll("{lime}★ {default}Noob of the Round {lime}: {darkred}%s", noobname); // Name of Noob player
		CPrintToChatAll("{darkred}=============== {purple}[{orchid}★ {green}Round{purple}-{lime}Stats {orchid}★{purple}] {darkred}===============");
		
	}
	if(sCheckMapEndBy.IntValue == 2 && sMaxRounds.IntValue == countround && countround > 0 && sMaxRounds.IntValue != 0)
	{
		MapEndText();
	}
	if(sCheckMapEndBy.IntValue == 3 && sWinLimit.IntValue == wincountct || sWinLimit.IntValue == wincountt && sWinLimit.IntValue != 0)
	{
		MapEndText();
	}
}
void MapEndText()
{
	if(sStatsEnabled.BoolValue && sShowStatsOnMap.BoolValue)
    {
		int ctscore = GetTeamScore(3);
		int tscore = GetTeamScore(2);
		int noobEnd = 0;
		int mostkillsEnd = 0;
		int mosthsEnd = 0;
		int mostknivesEnd = 0;
		int mostgrenadesEnd = 0;
		char WinnerEnd[32];
		if(ctscore > tscore){WinnerEnd = "Counter-Terrorist";}
		if(tscore > ctscore){WinnerEnd = "Terrorist";}
		for(new i = 1; i < MaxClients; i++) // Get kills, Headshots and knife kills
		{
			if(IsClientInGame(i) && !IsClientSourceTV(i) && GetClientTeam(i) != 1 && kills[i] > 0)
			{
				if(killsEnd[i] > killsEnd[mostkillsEnd] || killsEnd[i] == killsEnd[mostkillsEnd] && damage1End[i] > damage1End[mostkillsEnd])
				{
					mostkillsEnd = i;
				}
				if(hsEnd[i] > 0 && (hsEnd[i] > hsEnd[mosthsEnd] || hsEnd[i] == hsEnd[mosthsEnd]))
				{
					mosthsEnd = i;
				}
				if(knivesEnd[i] > 0 && (knivesEnd[i] > knivesEnd[mostknivesEnd] || knivesEnd[i] == knivesEnd[mostknivesEnd]))
				{
					mostknivesEnd = i;
				}
				if(grenadeEnd[i] > 0 && (grenadeEnd[i] > grenadeEnd[mostgrenadesEnd] || grenadeEnd[i] == grenadeEnd[mostgrenadesEnd]))
				{
					mostgrenadesEnd = i;
				}
			}
			if(IsClientInGame(i) && !IsClientSourceTV(i) && GetClientTeam(i) != 1 && damage1End[i] <= 0)
			{
				noobEnd = i;
			}
		}
		char noobnameEnd[MAX_NAME_LENGTH];
		GetClientName(noobEnd, noobnameEnd, sizeof(noobnameEnd));
		char mvpnameEnd[MAX_NAME_LENGTH];
		GetClientName(mostkillsEnd, mvpnameEnd, sizeof(mvpnameEnd));
		char hnameEnd[MAX_NAME_LENGTH];
		GetClientName(mosthsEnd, hnameEnd, sizeof(hnameEnd));
		char knameEnd[MAX_NAME_LENGTH];
		GetClientName(mostknivesEnd, knameEnd, sizeof(knameEnd));
		char GnameEnd[MAX_NAME_LENGTH];
		GetClientName(mostgrenadesEnd, GnameEnd, sizeof(GnameEnd));
		CPrintToChatAll("{darkred}==========[{lime}★ {green}Map{default}-{green}Stats {lime}★{darkred}]==========");
		CPrintToChatAll("{lime}★ {default}Winner {lime}: {green}%s", WinnerEnd);
		if(mostkillsEnd > 0)CPrintToChatAll("{lime}★ {darkred}%s {default}is {lime}MVP {default}with {lime}%i {orchid}Kills {default}by Giving", mvpnameEnd, killsEnd[mostkillsEnd]); // Name of MVP player
		if(mostkillsEnd > 0)CPrintToChatAll("{lime}★{yellow} Damage {lime}%0.0f {default}in {lime}%i {yellow}Hits", damage1End[mostkillsEnd], hitsEnd[mostkillsEnd]);
		if(mosthsEnd > 0)CPrintToChatAll("{lime}★ {default}HeadHunter {lime}: {lime}%s {default}({lime}%i{default})", hnameEnd, hsEnd[mosthsEnd]); // HeadHunter of Map by which player
		if(mostknivesEnd > 0)CPrintToChatAll("{lime}★ {default}Most Knife kills {lime}: {yellow}%s {default}({yellow}%i{default})", knameEnd, knivesEnd[mostknivesEnd]); // Most Knife Kills in Map by which player
		if(mostgrenadesEnd > 0)CPrintToChatAll("{lime}★ {default}Most Grenade kills {lime}: {lime}%s {default}({lime}%i{default})", GnameEnd, grenadeEnd[mostgrenadesEnd]); // Most Grenades Kills in Map by which player
		if(noobEnd > 0)CPrintToChatAll("{lime}★ {default}Noob of the map {lime}: {darkred}%s", noobnameEnd); // Name of Noob player of Map
		CPrintToChatAll("{darkred}==========[{lime}★ {green}Map{default}-{green}Stats {lime}★{darkred}]==========");
	}
}
public Action Event_PlayerHurt(Handle event, const char[] name, bool dontBroadcast)
{
	int attacker = GetClientOfUserId(GetEventInt(event, "attacker"));
	int victim = GetClientOfUserId(GetEventInt(event, "userid"));
	if(attacker == 0)
	{
		return;
	}
	if(GetClientTeam(attacker) != GetClientTeam(victim))
	{
		float dmg = GetEventFloat(event, "dmg_health");
		damage1[attacker] += dmg;
		damage1End[attacker] += dmg;
		hits[attacker]++;
		hitsEnd[attacker]++;
	}
}
public Event_PlayerDeath(Handle event, const char[] name, bool dontBroadcast)
{
	int attacker = GetClientOfUserId(GetEventInt(event, "attacker"));
	int victim = GetClientOfUserId(GetEventInt(event, "userid"));
	GetClientName(attacker, KillerName, sizeof(KillerName));
	GetClientName(victim, VictimName, sizeof(VictimName));
	if(attacker == 0)
	{
		return;
	}
	if(GetClientTeam(attacker) != GetClientTeam(victim))
	{
		kills[attacker]++;
		killsEnd[attacker]++;
		firstblood++;
		if(firstblood == 1)
		{
			CPrintToChatAll("{darkred}[{lime}★ {green}Round{default}-{green}Stats {lime}★{darkred}] {green}%s {default}is the First Blooder by killing {lime}%s", KillerName, VictimName);
		}
		if(GetEventBool(event, "Headshot"))
		{
			hs[attacker]++;
			hsEnd[attacker]++;
			CPrintToChatAll("{darkred}[{lime}★ {green}Round{default}-{green}Stats {lime}★{darkred}] {green}%s {default}killed {lime}%s {default}with {yellow}Headshot", KillerName, VictimName);
			}
		char weapon[32];
		char sWeapon[32];
		GetEventString(event, "weapon", weapon, sizeof(weapon));
		GetClientWeapon(attacker, sWeapon, sizeof(sWeapon));
		if(StrContains(sWeapon, "knife", false) != -1 || (StrContains(sWeapon, "bayonet", false) != -1))
		{
			knives[attacker]++;
			knivesEnd[attacker]++;
			CPrintToChatAll("{darkred}[{lime}★ {green}Round{default}-{green}Stats {lime}★{darkred}] {green}%s {default}killd {lime}%s {default}with {yellow}Knife", KillerName, VictimName);
		}
		if(StrEqual(weapon, "hegrenade"))
		{
			CPrintToChatAll("{darkred}[{lime}★ {green}Round{default}-{green}Stats {lime}★{darkred}] {green}%s {default}killed {lime}%s {default}with {yellow}Grenade", KillerName, VictimName);
			grenade[attacker]++;
			grenadeEnd[attacker]++;
		}
	}
}
